#!/usr/bin/env ruby
###############################################################################
################     Script by Jim Clark - BanditBBS@gmail.com    #############
################     http://www.bandits-home-on-the-web.com       #############
################     Based on nagMailAck.rb and imap.rb           #############
################     used to check for emails with specific sub   #############
###############################################################################
require "optparse"
require "net/imap"
#$:.unshift(File.dirname(__FILE__) + '/../lib')
#$:.unshift('/usr/lib/ruby/gems/1.8/gems/rubyntlm-0.4.0/lib')
$:.unshift('/usr/local/rvm/gems/ruby-2.0.0-p247/gems/rubyntlm-0.4.0/lib')
require "net/ntlm"
require 'openssl'
#Net::IMAP::debug = true
###############################################################################
################        Set variables                             #############
###############################################################################
$version = "1.1"
$host = "xxx.xxx.com" #IMAP Server
$port = 143 #IMAP Port
$ssl = false #Use SSL
$user = "xxxxxxx" #IMAP User
$passwd = "xxxxxxxx" #IMAP Password
$subjectID = ARGV[0]
###############################################################################
################        Setup IMAP Connection with NTLM           #############
###############################################################################
module Kernel
  def suppress_warnings
    original_verbosity = $VERBOSE
    $VERBOSE = nil
    result = yield
    $VERBOSE = original_verbosity
    return result
  end
end
module Net
  class IMAP
    class NtlmAuthenticator
      def process(data)
        case @state
        when 1
          @state = 2
          t1 = Net::NTLM::Message::Type1.new()
          return t1.serialize
        when 2
          @state = 3
          t2 = Net::NTLM::Message.parse(data)
          t3 = t2.response({:user => @user, :password => @password}, {:ntlmv2 => (@ntlm_type == "ntlmv2")})
          return t3.serialize
        end
      end

      private

      def initialize(user, password, ntlm_type = "ntlmv2")
        @user = user
        @password = password
        @ntlm_type = @ntlm_type
        @state = 1
      end
    end
    add_authenticator "NTLM", NtlmAuthenticator

    class ResponseParser
      def continue_req
        match(T_PLUS)
        if lookahead.symbol == T_CRLF # means empty message
          return ContinuationRequest.new(ResponseText.new(nil, ""), @str)
        end
        match(T_SPACE)
        return ContinuationRequest.new(resp_text, @str)
      end
    end
  end
end
###############################################################################
################        Check each email for proper subject       #############
###############################################################################
def subjectcheck(eMailSubject,subjectString)
	#Define Variables
    subID = subjectString
    subject = eMailSubject
    if subject!=subID #Wrong subject for this check
      return false
    end #Return to main part of script
    $found=1
    return true
end
###############################################################################
################        Main script section                       #############
###############################################################################
###############################################################################
################        Option parser                             #############
###############################################################################
if $subjectID==nil
  printf "NTLM Email Subject Checker: Version "+ $version + " Usage: check_email_subject \"subject to test for\"\n"
  #printf $subjectID + "\n"
  exit(0)
end
###############################################################################
loop do
suppress_warnings {OpenSSL::SSL::VERIFY_PEER = OpenSSL::SSL::VERIFY_NONE}
imap = Net::IMAP.new($host, $port, $ssl) #Create new IMAP connection
imap.authenticate("NTLM", $user, $passwd) #Authenticate to IMAP connection
imap.select("Inbox") #Select the Inbox folder
messages_to_archive = []
@mailbox = "-1"
# retrieve all messages in the INBOX that are not marked as DELETED
$found=0
imap.search(["NOT", "DELETED"]).each do |message_id|
  @mailbox = imap.fetch(message_id, 'ENVELOPE')[0].attr['ENVELOPE'].to[0].mailbox
  @mailbox = @mailbox.gsub(/([_\-\.])+/, ' ').downcase
  @mailbox.gsub!(/\b([a-z])/) { $1.capitalize }
  envelope = imap.fetch(message_id, "ENVELOPE")[0].attr["ENVELOPE"]
  if subjectcheck(envelope.subject,$subjectID)
    messages_to_archive << message_id
    begin
      #create the mailbox, unless it already exists
      imap.create(@mailbox) unless imap.list('', @mailbox)
      rescue Net::IMAP::NoResponseError => error
    end
    #copy the message to the proper mailbox/label
    imap.copy(message_id, @mailbox)
  end
end
imap.store(messages_to_archive, "+FLAGS", [:Deleted]) unless messages_to_archive.empty? # archive the original messages
imap.logout # imap.disconnect
if $found==0
  #Exit Critical
  system('echo "Critical"')
  exit(2)
end
#Exit OK
system('echo "OK"')
exit(0)
end
